import { computed as F, watch as ue, ref as X, defineComponent as Re, provide as Ve, toRefs as Ae, useSlots as Ne, onMounted as Me, openBlock as h, createElementBlock as C, Fragment as q, createElementVNode as j, normalizeClass as U, unref as e, renderSlot as x, normalizeProps as ve, mergeProps as _, renderList as Q, toDisplayString as N, withModifiers as De, createCommentVNode as te, createTextVNode as W } from "vue";
const Oe = {
  items: {
    type: Array,
    default: () => [],
    required: !0,
    description: "Array of data objects, should be a flat array."
  },
  measures: {
    type: Array,
    default: () => [],
    required: !0,
    description: "Array of Measure objects representing the metrics"
  },
  dimensions: {
    type: Array,
    default: () => [],
    description: "Array of Dimension objects representing the row-dimensions"
  },
  pivot: {
    type: Object,
    default: null,
    description: "Single Pivot object representing the column-dimension. Limited to 1 for reduced complexity."
  },
  locale: {
    type: String,
    default: "en-US",
    description: "Locale setting for the table."
  },
  currentPage: {
    type: Number,
    default: 1,
    description: "Current page number."
  },
  noRowsCustom: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to use custom rows when no data is available."
  },
  emptyMessage: {
    type: String,
    default: "No Available Data",
    description: "Message to display when there is no available data."
  },
  filterOptions: {
    type: Array,
    default: null,
    description: "Array of filter options for the table."
  },
  hideFooter: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to hide the table footer."
  },
  hideHeader: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to hide the table header."
  },
  loading: {
    type: Boolean,
    default: !1,
    description: "Indicates whether the table is in a loading state."
  },
  rowsPerPage: {
    type: Number,
    default: 25,
    description: "Number of rows per page."
  },
  searchField: {
    type: [String, Array],
    default: "",
    description: "Field or fields to search within."
  },
  rowsItems: {
    type: Array,
    default: () => [25, 50, 100]
  },
  rowsOfPageSeparatorMessage: {
    type: String,
    default: "of"
  },
  searchValue: {
    type: String,
    default: "",
    description: "Value to search for within the specified field(s)."
  },
  showIndex: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to display an index column."
  },
  showIndexSymbol: {
    type: String,
    default: "#",
    description: "Symbol used for the index column."
  },
  showIndexClass: {
    type: String,
    default: "",
    description: "Class used for the index column."
  },
  oddRowClass: {
    type: String,
    default: "odd-row",
    description: "CSS class applied to odd-numbered rows."
  },
  evenRowClass: {
    type: String,
    default: "even-row",
    description: "CSS class applied to even-numbered rows."
  },
  oddRowCellClass: {
    type: String,
    default: "odd-row-cell",
    description: "CSS class applied to cells in odd-numbered rows."
  },
  customTableRowClass: {
    type: Function,
    default: () => null,
    description: "Custom function to apply classes to tablerows <tr>."
  },
  customTableDataClass: {
    type: Function,
    default: () => null,
    description: "Custom function to apply classes to tablerows <td>."
  },
  evenRowCellClass: {
    type: String,
    default: "even-row-cell",
    description: "CSS class applied to cells in even-numbered rows."
  },
  sortBy: {
    type: String,
    default: "",
    description: "Field or fields to sort by."
  },
  sortType: {
    type: String,
    default: "asc",
    description: "Sort type or types (ascending or descending)."
  },
  sortPivotValue: {
    type: String,
    default: "",
    description: "Sort pivotValue when pivot is active"
  },
  tableClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the table element."
  },
  innerTableClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the inner table element."
  },
  headerClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the table header element."
  },
  mustSort: {
    type: Boolean,
    default: !1,
    description: "Indicates whether sorting is required."
  },
  tableNodeId: {
    type: String,
    default: "",
    description: "ID attribute for the table element."
  },
  nullFillText: {
    type: String,
    default: "-",
    description: "Text to be shown if cellvalue is null"
  }
};
function E(s, a) {
  if (s.includes(".")) {
    const v = s.split("."), { length: d } = v;
    let r, f = 0;
    for (; f < d; ) {
      if (f === 0)
        r = a[v[0]];
      else if (r && typeof r == "object")
        r = r[v[f]];
      else {
        r = "";
        break;
      }
      f += 1;
    }
    return r ?? "";
  }
  return a[s];
}
function he(s, a, v, d) {
  return s == null ? d : Array.isArray(s) ? s.join(", ") : (a.formatFunc ? s = a.formatFunc(s) : a.numberFormat && (s = new Intl.NumberFormat(v, a.numberFormat).format(s)), a.prefix && (s = a.prefix + s), a.suffix && (s = s + a.suffix), s);
}
function _e(s, a, v, d) {
  const r = E(s.value, a);
  return he(r, s, v, d);
}
function Be(s, a, v, d, r) {
  var T;
  let f;
  return s.pivotValue ? f = (T = a.items.find((S) => S[v.value] === s.pivotValue)) == null ? void 0 : T[s.value] : f = E(s.value, a.dimensions), he(f, s, d, r);
}
function je(s, a, v, d, r, f, T, S, g) {
  const z = (p) => {
    if (typeof T.value == "string" && T.value !== "")
      return E(T.value, p);
    if (Array.isArray(T.value)) {
      let l = "";
      return T.value.forEach((y) => {
        l += E(y, p);
      }), l;
    }
    return Object.values(p).join(" ");
  }, M = F(() => {
    if (r.value) {
      const p = f.value.map((y) => y.value), l = d.value.reduce((y, P) => {
        const w = p.map((n) => P[n]).join("|"), k = y.find((n) => n.key === w);
        if (k)
          k.items.push(P);
        else {
          const n = Object.fromEntries(Object.entries(P).filter(([c]) => p.includes(c)));
          y.push({ key: w, dimensions: n, items: [P] });
        }
        return y;
      }, []);
      if (S.value !== "") {
        const y = new RegExp(S.value, "i");
        return l.filter((P) => y.test(P.key));
      }
      return l;
    }
    if (S.value !== "") {
      const p = new RegExp(S.value, "i");
      return d.value.filter((l) => p.test(z(l)));
    }
    return d.value;
  }), D = F(() => {
    let p = [...M.value];
    return r.value ? p : v.value ? (v.value.forEach((l) => {
      p = p.filter((y) => {
        const { field: P, comparison: w, criteria: k } = l;
        if (typeof w == "function")
          return w(E(P, y), k);
        const n = E(P, y);
        if (n === null)
          return !1;
        switch (w) {
          case "=":
            return n === k;
          case "!=":
            return n !== k;
          case ">":
            return n > k;
          case "<":
            return n < k;
          case "<=":
            return n <= k;
          case ">=":
            return n >= k;
          case "between":
            return n >= Math.min(...k) && n <= Math.max(...k);
          case "in":
            return Array.isArray(k) ? k.includes(n) : !0;
          default:
            return n === k;
        }
      });
    }), p) : M.value;
  });
  ue(
    D,
    (p) => {
      v.value && g("updateFilter", p);
    },
    { immediate: !0, deep: !0 }
  );
  const B = F(() => {
    var n;
    if (a.value === null)
      return D.value;
    const p = [...D.value], { sortBy: l, sortDesc: y, sortPivotValue: P } = a.value, w = (n = s.value.find((c) => c.value === l)) == null ? void 0 : n.sortFunc;
    return p.sort((c, u) => {
      var R, $, K, Z;
      let o, m;
      return r.value ? P ? (o = w ? w((R = c.items.find((G) => G[r.value.value] === P)) == null ? void 0 : R[l]) : ($ = c.items.find((G) => G[r.value.value] === P)) == null ? void 0 : $[l], m = w ? w((K = u.items.find((G) => G[r.value.value] === P)) == null ? void 0 : K[l]) : (Z = u.items.find((G) => G[r.value.value] === P)) == null ? void 0 : Z[l]) : (o = w ? w(c.dimensions[l]) : c.dimensions[l], m = w ? w(u.dimensions[l]) : u.dimensions[l]) : (o = w ? w(E(l, c)) : E(l, c), m = w ? w(E(l, u)) : E(l, u)), o == null && m != null ? 1 : o != null && m == null ? -1 : o == null && m == null ? 0 : o < m ? y ? 1 : -1 : o > m ? y ? -1 : 1 : 0;
    });
  }), Y = F(() => B.value.length);
  return {
    totalItems: B,
    totalItemsLength: Y
  };
}
function Le(s, a, v, d, r, f, T, S, g, z, M, D) {
  const B = F(() => r.value ? [...new Set(s.value.map((n) => n[r.value.value]))] : []), p = X(
    ((n, c, u) => n && n !== "" ? {
      sortBy: n,
      sortDesc: c === "desc",
      sortPivotValue: u
    } : null)(g.value, z.value, M.value)
  );
  let l = [];
  const y = F(() => {
    if (r.value) {
      const u = B.value.flatMap((o) => d.value.map((R) => ({
        ...R,
        pivotValue: o
      })));
      l = [
        ...v.value.map((o) => ({ ...o, type: "tableRow" })),
        ...u.map((o) => ({ ...o, type: "tableValue" }))
      ];
    } else
      l = [
        ...v.value.map((u) => ({ ...u, type: "tableRow" })),
        ...d.value.map((u) => ({ ...u, type: "tableValue" }))
      ];
    const n = l.map((u) => {
      const o = Object.assign(u);
      return o.sortable && (o.sortType = "none"), p.value && o.value === p.value.sortBy && p.value.sortPivotValue ? p.value.sortPivotValue === o.pivotValue ? o.sortType = p.value.sortDesc ? "desc" : "asc" : o.sortType = "none" : p.value && o.value === p.value.sortBy && (o.sortType = p.value.sortDesc ? "desc" : "asc"), o;
    });
    let c = [];
    return T.value ? c = [{
      text: a.value,
      value: "index",
      cssClass: S.value
    }, ...n] : c = n, c;
  }), P = F(() => {
    const n = [];
    if (r.value) {
      const c = y.value.reduce(
        (u, o) => {
          const m = o.pivotValue;
          let R;
          o.pivotValue ? r.value.formatFunc ? R = r.value.formatFunc(o.pivotValue) : R = o.pivotValue : R = null;
          const $ = u[u.length - 1];
          return $ && $.text === R && !$.isIndex && $.originalText === m ? $.count++ : u.push({
            type: "pivot",
            isIndex: o.value === "index",
            text: R,
            originalText: m,
            count: 1,
            cssClass: o.cssClass ?? ""
          }), u;
        },
        []
      );
      n.push(c);
    }
    if (y.value.findIndex((c) => c.parent) > -1) {
      const c = y.value.reduce(
        (u, o) => {
          var K;
          const m = ((K = o.parent) == null ? void 0 : K.text) || null, R = o.pivotValue, $ = u[u.length - 1];
          return $ && $.text === m && !$.isIndex && $.pivotValue === R ? $.count++ : u.push({
            type: "parent",
            isIndex: o.value === "index",
            pivotValue: R,
            text: m,
            count: 1,
            cssClass: o.cssClass ?? ""
          }), u;
        },
        []
      );
      n.push(c);
    }
    return n;
  }), w = F(() => y.value.map((n) => n.value));
  return {
    clientSortOptions: p,
    headerColumns: w,
    headersForRenderParents: P,
    headersForRender: y,
    updateSortField: (n, c, u = !1, o = void 0) => {
      let m = null;
      u ? m = c === "none" ? null : c : c === "none" ? m = "asc" : c === "asc" ? m = "desc" : m = f.value ? "asc" : null, m === null ? p.value = null : p.value = {
        sortBy: n,
        sortDesc: m === "desc",
        sortPivotValue: o
      }, D("updateSort", {
        sortPivotValue: o,
        sortType: m,
        sortBy: n
      });
    }
  };
}
function Ee(s, a) {
  const v = F(() => s.value.findIndex((f) => f === a.value) === -1 ? [a.value, ...s.value] : s.value), d = X(a.value);
  return {
    rowsItemsComputed: v,
    rowsPerPageRef: d,
    updateRowsPerPage: (f) => {
      d.value = f;
    }
  };
}
function ze(s, a, v, d) {
  const r = X(s.value), f = F(() => Math.ceil(v.value / d.value)), T = F(
    () => f.value === 0 || r.value === f.value
  ), S = F(() => r.value === 1);
  return {
    currentPaginationNumber: r,
    maxPaginationNumber: f,
    isLastPage: T,
    isFirstPage: S,
    nextPage: () => {
      v.value !== 0 && (T.value || a.value || (r.value += 1));
    },
    prevPage: () => {
      v.value !== 0 && (S.value || a.value || (r.value -= 1));
    },
    updatePage: (B) => {
      a.value || (r.value = B);
    },
    updateCurrentPaginationNumber: (B) => {
      r.value = B;
    }
  };
}
function Ge(s, a, v, d, r) {
  const f = F(() => (s.value - 1) * a.value + 1), T = F(() => Math.min(d.value.length, s.value * a.value)), S = F(() => a.value === -1 ? d.value : d.value.slice(f.value - 1, T.value)), g = F(() => v.value ? r.value ? S.value.map((M, D) => (M.dimensions = { index: f.value + D, ...M.dimensions }, M)) : S.value.map((M, D) => ({ index: f.value + D, ...M })) : S.value), z = F(() => g.value);
  return {
    currentPageFirstIndex: f,
    currentPageLastIndex: T,
    pageItems: z
  };
}
const He = [
  { name: "scroll", description: "Triggered when scrolling" },
  { name: "clickRow", description: "Triggered when a row is clicked" },
  { name: "clickCell", description: "Triggered when a cell is clicked" },
  { name: "updateSort", description: "Triggered when sorting is updated" },
  { name: "updateFilter", description: "Triggered when filtering is updated" },
  { name: "updatePageItems", description: "Triggered when page items are updated" },
  { name: "updateTotalItems", description: "Triggered when total items are updated" },
  { name: "mouseover", description: "Triggered when mouse is over" },
  { name: "mouseleave", description: "Triggered when mouse leaves" }
], qe = He.map((s) => s.name), We = ["id"], Ue = ["colspan"], Ke = { class: "header" }, Je = {
  key: 3,
  class: "header-text"
}, Qe = ["onClick"], Xe = { class: "header" }, Ye = {
  key: 3,
  class: "header-text"
}, Ze = ["id"], et = ["role", "onClick", "onMouseover", "onMouseleave"], tt = { id: "errors" }, st = { style: { color: "red" } }, rt = { key: 6 }, ot = /* @__PURE__ */ Re({
  __name: "PivotDataTable",
  props: Oe,
  emits: qe,
  setup(s, { expose: a, emit: v }) {
    const d = X([]), r = X();
    Ve("dataTable", r);
    const f = s, {
      measures: T,
      dimensions: S,
      pivot: g,
      locale: z,
      tableNodeId: M,
      currentPage: D,
      filterOptions: B,
      emptyMessage: Y,
      noRowsCustom: p,
      items: l,
      loading: y,
      mustSort: P,
      rowsItems: w,
      rowsPerPage: k,
      searchField: n,
      searchValue: c,
      showIndex: u,
      sortBy: o,
      sortType: m,
      sortPivotValue: R,
      showIndexSymbol: $,
      showIndexClass: K,
      nullFillText: Z,
      hideFooter: G,
      customTableRowClass: Ce,
      customTableDataClass: Se
    } = Ae(f), O = Ne(), ee = v, { clientSortOptions: Pe, headersForRenderParents: ke, headersForRender: L, updateSortField: se } = Le(
      l,
      $,
      S,
      T,
      g,
      P,
      u,
      K,
      o,
      m,
      R,
      ee
    ), { totalItems: fe, totalItemsLength: re } = je(
      L,
      Pe,
      B,
      l,
      g,
      S,
      n,
      c,
      ee
    ), { rowsItemsComputed: Ie, rowsPerPageRef: oe, updateRowsPerPage: Te } = Ee(w, k), { currentPaginationNumber: ie, maxPaginationNumber: de, isLastPage: ye, isFirstPage: me, nextPage: ne, prevPage: ae, updatePage: le } = ze(D, y, re, oe), { currentPageFirstIndex: pe, currentPageLastIndex: ce, pageItems: ge } = Ge(
      ie,
      oe,
      u,
      fe,
      g
    ), xe = (i, V, t, b) => {
      ee("clickCell", i, V, t, b);
    };
    ue(oe, () => {
      le(1);
    }), ue([c, B], () => {
      le(1);
    }), ue(
      [l, g],
      () => {
        Fe();
      },
      { immediate: !0 }
    );
    const we = X(!1);
    function Fe() {
      d.value = [], g.value && Array.isArray(g.value) ? d.value.push({
        type: "propError",
        text: "pivot is of type Array"
      }) : g.value && $e() && d.value.push({
        type: "dataShapeError",
        text: "duplicate item Objects (by rows * columns) found in items"
      });
    }
    Me(() => {
      r.value.addEventListener("scroll", () => {
        we.value = r.value.scrollLeft > 0;
      });
    }), a({
      currentPageFirstIndex: pe,
      currentPageLastIndex: ce,
      clientItemsLength: re,
      totalItems: fe,
      maxPaginationNumber: de,
      currentPaginationNumber: ie,
      isLastPage: ye,
      isFirstPage: me,
      nextPage: ne,
      prevPage: ae,
      updatePage: le,
      updateSortField: se,
      rowsPerPageOptions: Ie,
      rowsPerPageActiveOption: oe,
      updateRowsPerPageActiveOption: Te
    });
    function $e() {
      const i = [...S.value.map((t) => t.value), g.value.value], V = /* @__PURE__ */ new Set();
      for (let t = 0; t < l.value.length; t++) {
        const b = i.map((I) => l.value[t][I]).join("|");
        if (V.has(b))
          return !0;
        V.add(b);
      }
      return !1;
    }
    return (i, V) => (h(), C(q, null, [
      j("div", {
        ref_key: "dataTable",
        ref: r,
        class: U(["vue3-pivot-data-table", [i.tableClassName]]),
        onScroll: V[0] || (V[0] = (t) => i.$emit("scroll", t))
      }, [
        j("table", {
          id: e(M),
          class: U({
            [i.innerTableClassName]: !0,
            "show-shadow": we.value
          })
        }, [
          e(O)["customize-headers"] ? x(i.$slots, "customize-headers", ve(_({ key: 0 }, { headersForRender: e(L), updateSortField: e(se) })), void 0, !0) : e(L).length && !i.hideHeader ? (h(), C("thead", {
            key: 1,
            class: U([i.headerClassName])
          }, [
            (h(!0), C(q, null, Q(e(ke), (t, b) => (h(), C("tr", {
              key: "headerRowGroup" + b
            }, [
              (h(!0), C(q, null, Q(t, (I, A) => (h(), C("th", {
                key: "pivotHeader" + A,
                colspan: I.count,
                class: U([
                  {
                    shadow: A === 0,
                    [I.cssClass ?? ""]: !0,
                    [I.type ?? ""]: !0
                  }
                ])
              }, [
                j("span", Ke, [
                  e(O)[`header-${I.type}-${I.text}`] ? x(i.$slots, `header-${I.type}-${I.text}`, _({
                    key: 0,
                    ref_for: !0
                  }, I), void 0, !0) : e(O)[`header-${I.type}`] ? x(i.$slots, `header-${I.type}`, _({
                    key: 1,
                    ref_for: !0
                  }, I), void 0, !0) : e(O).header ? x(i.$slots, "header", _({
                    key: 2,
                    ref_for: !0
                  }, I), void 0, !0) : (h(), C("span", Je, N(I.text), 1))
                ])
              ], 10, Ue))), 128))
            ]))), 128)),
            j("tr", null, [
              (h(!0), C(q, null, Q(e(L), (t, b) => (h(), C("th", {
                key: b,
                role: "button",
                tabindex: 0,
                class: U([
                  {
                    sortable: t.sortable,
                    none: t.sortable && t.sortType === "none",
                    desc: t.sortable && t.sortType === "desc",
                    asc: t.sortable && t.sortType === "asc",
                    shadow: b === 0,
                    [t.cssClass ?? ""]: !0,
                    [t.type ?? ""]: !0
                  }
                ]),
                onClick: De((I) => t.sortable && t.sortType ? e(se)(t.value, t.sortType, !1, t.pivotValue) : null, ["stop"])
              }, [
                j("span", Xe, [
                  e(O)[`header-${t.value}`] ? x(i.$slots, `header-${t.value}`, _({
                    key: 0,
                    ref_for: !0
                  }, t), void 0, !0) : e(O)[`header-${t.value.toLowerCase()}`] ? x(i.$slots, `header-${t.value.toLowerCase()}`, _({
                    key: 1,
                    ref_for: !0
                  }, t), void 0, !0) : e(O).header ? x(i.$slots, "header", _({
                    key: 2,
                    ref_for: !0
                  }, t), void 0, !0) : (h(), C("span", Ye, N(t.text), 1)),
                  t.sortable && e(O)["sort-icon"] ? x(i.$slots, "sort-icon", _({
                    key: 4,
                    ref_for: !0
                  }, t), void 0, !0) : t.sortable ? (h(), C("i", {
                    key: t.sortType ? t.sortType : "none",
                    class: U(["sortType-icon", { desc: t.sortType === "desc" }])
                  }, null, 2)) : te("", !0)
                ])
              ], 10, Qe))), 128))
            ])
          ], 2)) : te("", !0),
          j("tbody", null, [
            (h(!0), C(q, null, Q(e(ge), (t, b) => {
              var I;
              return h(), C("tr", {
                id: `row-${b}`,
                key: b,
                class: U([
                  { [i.oddRowClass]: (b + 1) % 2 === 0 },
                  { [i.evenRowClass]: b % 2 === 0 },
                  ...((I = e(Ce)) == null ? void 0 : I({ index: b, item: t })) ?? []
                ]),
                role: "button",
                tabindex: 0
              }, [
                (h(!0), C(q, null, Q(e(L), (A, J) => {
                  var be;
                  return h(), C("td", {
                    key: J,
                    role: e(L)[J].clickable || e(L)[J].hoverable ? "button" : "",
                    tabindex: "0",
                    class: U([
                      {
                        [i.oddRowCellClass]: (b + 1) % 2 === 0,
                        [i.evenRowCellClass]: b % 2 === 0,
                        shadow: J === 0,
                        [A.cssClass ?? ""]: !0,
                        [A.type ?? ""]: !0
                      },
                      ...((be = e(Se)) == null ? void 0 : be({
                        header: A,
                        item: e(g) && A.pivotValue ? t.items.find((H) => H[e(g).value] === A.pivotValue) : e(g) ? t.dimensions : t,
                        index: b
                      })) ?? []
                    ]),
                    onClick: (H) => xe(t, e(L)[J], b, H),
                    onMouseover: (H) => ee("mouseover", t, e(L)[J], H),
                    onMouseleave: (H) => ee("mouseleave", t, H)
                  }, [
                    e(O)[`item-${A.value}`] ? x(i.$slots, `item-${A.value}`, _(
                      {
                        key: 0,
                        ref_for: !0
                      },
                      e(g) && A.pivotValue ? t.items.find((H) => H[e(g).value] === A.pivotValue) : e(g) ? t.dimensions : t
                    ), void 0, !0) : e(O).item ? x(i.$slots, "item", _({
                      key: 1,
                      ref_for: !0
                    }, { pivot: e(g), item: t }), void 0, !0) : e(g) ? (h(), C(q, { key: 2 }, [
                      W(N(e(Be)(A, t, e(g), e(z), e(Z))), 1)
                    ], 64)) : (h(), C(q, { key: 3 }, [
                      W(N(e(_e)(A, t, e(z), e(Z))), 1)
                    ], 64))
                  ], 42, et);
                }), 128))
              ], 10, Ze);
            }), 128))
          ]),
          e(O)["customize-footers"] ? x(i.$slots, "customize-footers", ve(_({ key: 2 }, {
            headersForRender: e(L),
            updateSortField: e(se)
          })), void 0, !0) : te("", !0)
        ], 10, We)
      ], 34),
      d.value.length ? x(i.$slots, "errors", { key: 0 }, () => [
        j("div", tt, [
          j("ul", null, [
            (h(!0), C(q, null, Q(d.value, (t, b) => (h(), C("li", {
              key: "error" + b
            }, [
              j("span", st, N(t.type) + ":", 1),
              W(" " + N(t.text), 1)
            ]))), 128))
          ])
        ])
      ], !0) : e(y) ? x(i.$slots, "loading", { key: 1 }, () => [
        V[3] || (V[3] = W(" Slot: loading "))
      ], !0) : !e(l).length && !e(y) && e(p) ? x(i.$slots, "no-rows-custom", { key: 2 }, () => [
        V[4] || (V[4] = W(" Slot: no-rows-custom "))
      ], !0) : !e(l).length && !e(y) ? x(i.$slots, "no-rows", { key: 3 }, () => [
        W(N(e(Y)), 1)
      ], !0) : !e(ge).length && !e(y) ? x(i.$slots, "empty-message", { key: 4 }, () => [
        W(N(e(Y)), 1)
      ], !0) : te("", !0),
      e(O).footer ? x(i.$slots, "footer", ve(_({ key: 5 }, {
        currentPageFirstIndex: e(pe),
        currentPageLastIndex: e(ce),
        rowsOfPageSeparatorMessage: i.rowsOfPageSeparatorMessage,
        totalItemsLength: e(re),
        isFirstPage: e(me),
        isLastPage: e(ye),
        currentPaginationNumber: e(ie),
        maxPaginationNumber: e(de),
        nextPage: e(ne),
        prevPage: e(ae),
        updatePage: e(le)
      })), void 0, !0) : e(G) ? te("", !0) : (h(), C("div", rt, [
        W(N(`${e(pe)}–${e(ce)}`) + " " + N(i.rowsOfPageSeparatorMessage) + " " + N(e(re)) + " ", 1),
        j("button", {
          onClick: V[1] || (V[1] = //@ts-ignore
          (...t) => e(ae) && e(ae)(...t))
        }, N("<")),
        W(" " + N(e(D)) + " of " + N(e(de)) + " ", 1),
        j("button", {
          onClick: V[2] || (V[2] = //@ts-ignore
          (...t) => e(ne) && e(ne)(...t))
        }, ">")
      ]))
    ], 64));
  }
});
const nt = (s, a) => {
  const v = s.__vccOpts || s;
  for (const [d, r] of a)
    v[d] = r;
  return v;
}, ut = /* @__PURE__ */ nt(ot, [["__scopeId", "data-v-652f163d"]]);
export {
  ut as default
};
